<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ProteanResources.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.resources</a> &gt; <span class="el_source">ProteanResources.java</span></div><h1>ProteanResources.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.resources;

import io.gitlab.littlesaints.protean.configuration.Config;
import io.gitlab.littlesaints.protean.configuration.Props;
import io.gitlab.littlesaints.protean.event.*;

import java.util.Optional;
import java.util.concurrent.atomic.AtomicLong;
import java.util.function.Function;

/**
 * @author Varun Anand
 * @since 1.0
 */
public interface ProteanResources {

	String GC = &quot;protean::runnable::java::runtime::gc&quot;;
	String THREAD_SAFE_EVENT_SUPPLIER = &quot;protean::event::supplier::thread-safe-event&quot;;
	String SINGLE_THREAD_EVENT_SUPPLIER = &quot;protean::event::supplier::single-thread-event&quot;;
	String SIMPLE_EVENT_ACCESSOR = &quot;protean::event::accessor::simple-event&quot;;
	String CONTEXT_RESULT_MAPPER = &quot;protean::context::result-mapper&quot;;

<span class="fc" id="L43">	class _Registrar implements Registrar {</span>
		static {
<span class="fc" id="L45">			ResourceLocator.REGISTRY.register(&quot;_PROTEAN&quot;, new Locator());</span>
<span class="fc" id="L46">		}</span>

		@Override
		public String toString() {
<span class="fc" id="L50">			return &quot;ProteanResources::Registrar&quot;;</span>
		}
	}

	class Locator implements ResourceLocator {

		private final Props resources;

<span class="fc" id="L58">		private Locator() {</span>
<span class="fc" id="L59">			resources = new Props();</span>
<span class="fc" id="L60">			resources.put(ProteanResources.GC, newGCRunnable());</span>
<span class="fc" id="L61">			resources.put(ProteanResources.THREAD_SAFE_EVENT_SUPPLIER, threadSafeEventSupplier());</span>
<span class="fc" id="L62">			resources.put(ProteanResources.SINGLE_THREAD_EVENT_SUPPLIER, singleThreadEventSupplier());</span>
<span class="fc" id="L63">			resources.put(ProteanResources.SIMPLE_EVENT_ACCESSOR, simpleEventAccessor());</span>
<span class="fc" id="L64">			resources.put(ProteanResources.CONTEXT_RESULT_MAPPER, defaultResultMapper());</span>
<span class="fc" id="L65">		}</span>

		private &lt;E&gt; Function&lt;E, E&gt; defaultResultMapper() {
<span class="fc" id="L68">			return e -&gt; e;</span>
		}

		private Runnable newGCRunnable() {
<span class="fc" id="L72">			final Runtime runtime = Runtime.getRuntime();</span>
<span class="fc" id="L73">			return runtime::gc;</span>
		}

		@Override
		public &lt;T&gt; Optional&lt;T&gt; doLookup(String name) {
<span class="fc" id="L78">			return Optional.ofNullable(resources.get(name));</span>
		}

		private Function&lt;Config, ?&gt; threadSafeEventSupplier() {
<span class="fc" id="L82">			return ThreadSafeEvent::new;</span>
		}

		private Function&lt;Config, ?&gt; singleThreadEventSupplier() {
<span class="fc" id="L86">			return SingleThreadEvent::new;</span>
		}

		private EventAccessor&lt;SimpleEvent, ?&gt; simpleEventAccessor() {
<span class="fc" id="L90">			final AtomicLong sequence = new AtomicLong();</span>
<span class="fc" id="L91">			return new EventAccessor&lt;SimpleEvent, Object&gt;() {</span>

				@Override
				public long getIdentifier(SimpleEvent event) {
<span class="fc" id="L95">					return event.getIdentifier();</span>
				}

				@Override
				public void setState(SimpleEvent event, State state) {
<span class="fc" id="L100">					event.setState(state);</span>
<span class="fc" id="L101">				}</span>

				@Override
				public State getState(SimpleEvent event) {
<span class="fc" id="L105">					return event.getState();</span>
				}

				@Override
				public long getStartEpochMillis(SimpleEvent event) {
<span class="fc" id="L110">					return event.getStartEpochMillis();</span>
				}

				@Override
				public void initialize(SimpleEvent event, Object payload) {
<span class="fc" id="L115">					event.init(sequence::incrementAndGet);</span>
<span class="fc" id="L116">					event.setPayload(payload);</span>
<span class="fc" id="L117">				}</span>

				@Override
				public &lt;T&gt; T getConf(SimpleEvent event, String key) {
<span class="nc" id="L121">					return null;</span>
				}
			};
		}
	}
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>